Index: include/reactos/undocuser.h
===================================================================
--- include/reactos/undocuser.h	(revision 68654)
+++ include/reactos/undocuser.h	(working copy)
@@ -60,6 +60,9 @@
 #define DCX_KEEPLAYOUT   0x40000000
 #define DCX_PROCESSOWNED 0x80000000
 
+/* Non SDK TPM types.*/
+#define TPM_SYSTEM_MENU  0x00000200
+
 /* NtUserCreateWindowEx dwFlags bits. */
 #define NUCWE_ANSI       0x00000001
 #define NUCWE_SIDEBYSIDE 0x40000000
@@ -132,8 +135,17 @@
 //
 // Undocumented flags for DrawCaptionTemp
 //
+#define DC_NOVISIBLE 0x0800
 #define DC_NOSENDMSG 0x2000
+#define DC_FRAME     0x8000  // Missing from WinUser.H!
 
+//
+// Undocumented states for DrawFrameControl
+//
+#define DFCS_MENUARROWUP   0x0008
+#define DFCS_MENUARROWDOWN 0x0010
+
+
 #define STARTF_SCRNSAVER 0x80000000
 
 #define MOD_WINLOGON_SAS 0x8000
Index: win32ss/CMakeLists.txt
===================================================================
--- win32ss/CMakeLists.txt	(revision 68654)
+++ win32ss/CMakeLists.txt	(working copy)
@@ -149,6 +149,7 @@
     user/ntuser/winpos.c
     user/ntuser/winsta.c
     user/ntuser/object.c
+    user/rtl/text.c
     gdi/ntgdi/arc.c
     gdi/ntgdi/bezier.c
     gdi/ntgdi/bitblt.c
Index: win32ss/user/ntuser/callback.c
===================================================================
--- win32ss/user/ntuser/callback.c	(revision 68654)
+++ win32ss/user/ntuser/callback.c	(working copy)
@@ -393,6 +393,7 @@
           case WM_WINDOWPOSCHANGING:
           case WM_SIZING:
           case WM_MOVING:
+          case WM_MEASUREITEM:
             TRACE("Copy lParam, Message %u Size %d lParam %d!\n", Message, lParamBufferSize, lParam);
             if (InSendMessage)
                // Copy into kernel space.
Index: win32ss/user/ntuser/defwnd.c
===================================================================
--- win32ss/user/ntuser/defwnd.c	(revision 68654)
+++ win32ss/user/ntuser/defwnd.c	(working copy)
@@ -11,7 +11,24 @@
 
 DBG_DEFAULT_CHANNEL(UserDefwnd);
 
+INT WINAPI DrawTextExWorker( HDC hdc, LPWSTR str, INT i_count,
+                        LPRECT rect, UINT flags, LPDRAWTEXTPARAMS dtp );
 
+INT WINAPI DrawTextW( HDC hdc, LPCWSTR str, INT count, LPRECT rect, UINT flags )
+{
+    DRAWTEXTPARAMS dtp;
+
+    memset (&dtp, 0, sizeof(dtp));
+    dtp.cbSize = sizeof(dtp);
+    if (flags & DT_TABSTOP)
+    {
+        dtp.iTabLength = (flags >> 8) & 0xff;
+        flags &= 0xffff00ff;
+    }
+    return DrawTextExWorker(hdc, (LPWSTR)str, count, rect, flags, &dtp);
+}
+
+
 HBRUSH FASTCALL
 DefWndControlColor(HDC hDC, UINT ctlType)
 {
@@ -362,7 +379,43 @@
     co_IntSendMessage(UserHMGetHandle(pwnd), WM_PRINTCLIENT, (WPARAM)hdc, uFlags);
 }
 
+BOOL
+UserPaintCaption(PWND pWnd, INT Flags)
+{
+  BOOL Ret = FALSE;
 
+  if ( pWnd->style & WS_VISIBLE && (pWnd->style & WS_CAPTION) == WS_CAPTION )
+  {
+    /* 
+     * When themes are not enabled we can go on and paint the non client area.
+     * However if we do that with themes enabled we will draw a classic frame.
+     * This is sovled by sending a themes specific message to notify the themes
+     * engine that the caption needs to be redrawn 
+     */
+      if (gpsi->dwSRVIFlags & SRVINFO_APIHOOK)
+      {
+        /* 
+         * This will cause uxtheme to either paint the themed caption or call
+         * RealUserDrawCaption in order to draw the classic caption when themes
+         * are disabled but the themes service is enabled
+         */
+         co_IntSendMessage(UserHMGetHandle(pWnd), WM_NCUAHDRAWCAPTION, Flags, 0);
+      }
+      else
+      {
+         HDC hDC = UserGetDCEx(pWnd, NULL, DCX_WINDOW|DCX_USESTYLE);
+         UserDrawCaptionBar(pWnd, hDC, Flags);
+         UserReleaseDC(pWnd, hDC, FALSE);
+      }
+      Ret = TRUE;
+   }
+   // Support window tray
+   return Ret;
+}
+
+INT FASTCALL IntMenuItemFromPoint(PWND pWnd, HMENU hMenu, POINT ptScreen);
+DWORD FASTCALL IntGetWindowContextHelpId( PWND pWnd );
+
 /*
    Win32k counterpart of User DefWindowProc
  */
@@ -424,6 +477,28 @@
          UserDerefObjectCo(Wnd->spwndParent);
          break;
 
+      case WM_KEYF1:
+      {
+         HELPINFO hi;
+         PMENU pMenu = UlongToHandle(Wnd->IDMenu);
+         hi.cbSize = sizeof(HELPINFO);
+         hi.MousePos = gpsi->ptCursor;
+         hi.iContextType = HELPINFO_MENUITEM;
+         hi.hItemHandle = UserHMGetHandle(Wnd);
+         hi.iCtrlId = (Wnd->style & (WS_POPUP|WS_CHILD)) == WS_CHILD ? IntMenuItemFromPoint(Wnd, UserHMGetHandle(pMenu), hi.MousePos) : 0;
+         hi.dwContextId = IntGetWindowContextHelpId(Wnd);
+
+         co_IntSendMessage( UserHMGetHandle(Wnd), WM_HELP, 0, (LPARAM)&hi );
+         break;
+      }
+
+      case WM_HELP:
+      {
+         PWND Parent = IntGetParent(Wnd);
+         co_IntSendMessage(UserHMGetHandle(Parent), Msg, wParam, lParam);
+         break;
+      }
+
       case WM_CLOSE:
          co_UserDestroyWindow(Wnd);
          break;
@@ -548,7 +623,9 @@
                  IntGetClientRect(Wnd, &ClientRect);
                  x = (ClientRect.right - ClientRect.left - UserGetSystemMetrics(SM_CXICON)) / 2;
                  y = (ClientRect.bottom - ClientRect.top - UserGetSystemMetrics(SM_CYICON)) / 2;
+                 UserReferenceObject(Wnd->pcls->spicn);
                  UserDrawIconEx(hDC, x, y, Wnd->pcls->spicn, 0, 0, 0, 0, DI_NORMAL | DI_COMPAT | DI_DEFAULTSIZE);
+                 UserDereferenceObject(Wnd->pcls->spicn);
              }
 
              IntEndPaint(Wnd, &Ps);
@@ -607,6 +684,53 @@
           return (DefWndHandleWindowPosChanged(Wnd, (WINDOWPOS*)lParam));
       }
 
+      case WM_NCCALCSIZE:
+      {
+         return NC_HandleNCCalcSize( Wnd, wParam, (RECTL *)lParam );
+      }
+
+      case WM_NCACTIVATE:
+      {
+          return NC_HandleNCActivate( Wnd, wParam, lParam );
+      }
+
+      //
+      // NC Paint mode.
+      //
+      case WM_NCPAINT:
+      {
+          HDC hDC = UserGetDCEx(Wnd, (HRGN)wParam, DCX_WINDOW | DCX_INTERSECTRGN | DCX_USESTYLE | DCX_KEEPCLIPRGN);
+          Wnd->state |= WNDS_FORCEMENUDRAW;
+          NC_DoNCPaint(Wnd, hDC, -1);
+          Wnd->state &= ~WNDS_FORCEMENUDRAW;
+          UserReleaseDC(Wnd, hDC, FALSE);
+          return 0;
+      }
+      //
+      //  Draw Caption mode.
+      //
+      //  wParam is DC_* flags.
+      //
+      case WM_NCUAHDRAWCAPTION:
+      {
+          HDC hDC = UserGetDCEx(Wnd, NULL, DCX_WINDOW|DCX_USESTYLE);
+          TRACE("WM_NCUAHDRAWCAPTION: wParam DC_ flags %d\n");
+          UserDrawCaptionBar(Wnd, hDC, wParam);
+          UserReleaseDC(Wnd, hDC, FALSE);
+          return 0;
+      }
+      //
+      //  Draw Frame mode.
+      //
+      //  wParam is HDC, lParam is DC_ACTIVE and or DCF_REDRAWHUNGWND.
+      //
+      case WM_NCUAHDRAWFRAME:
+      {
+          TRACE("WM_NCUAHDRAWFRAME: wParam hDC %p lParam DC_ flags %d\n",wParam,lParam);
+          NC_DoNCPaint(Wnd, (HDC)wParam, lParam|DC_NC);
+          return 0;
+      }
+
       /* ReactOS only. */
       case WM_CBT:
       {
Index: win32ss/user/ntuser/draw.c
===================================================================
--- win32ss/user/ntuser/draw.c	(revision 68654)
+++ win32ss/user/ntuser/draw.c	(working copy)
@@ -948,6 +948,14 @@
     WCHAR Symbol;
     switch(uFlags & 0xff)
     {
+        case DFCS_MENUARROWUP:
+            Symbol = '5';
+            break;
+
+        case DFCS_MENUARROWDOWN:
+            Symbol = '6';
+            break;
+
         case DFCS_MENUARROW:
             Symbol = '8';
             break;
@@ -980,8 +988,6 @@
     hFont = GreCreateFontIndirectW(&lf);
     /* save font */
     hOldFont = NtGdiSelectFont(dc, hFont);
-    // FIXME selecting color doesn't work
-#if 0
     if(uFlags & DFCS_INACTIVE)
     {
         /* draw shadow */
@@ -989,7 +995,6 @@
         GreTextOutW(dc, r->left + 1, r->top + 1, &Symbol, 1);
     }
     IntGdiSetTextColor(dc, IntGetSysColor((uFlags & DFCS_INACTIVE) ? COLOR_BTNSHADOW : COLOR_BTNTEXT));
-#endif
     /* draw selected symbol */
     GreTextOutW(dc, r->left, r->top, &Symbol, 1);
     /* restore previous settings */
@@ -1006,6 +1011,25 @@
 
 
 INT WINAPI
+FrameRect(HDC hDC, CONST RECT *lprc, HBRUSH hbr)
+{
+    HBRUSH oldbrush;
+    RECT r = *lprc;
+
+    if ((r.right <= r.left) || (r.bottom <= r.top)) return 0;
+    if (!(oldbrush = NtGdiSelectBrush(hDC, hbr))) return 0;
+
+    NtGdiPatBlt(hDC, r.left, r.top, 1, r.bottom - r.top, PATCOPY);
+    NtGdiPatBlt(hDC, r.right - 1, r.top, 1, r.bottom - r.top, PATCOPY);
+    NtGdiPatBlt(hDC, r.left, r.top, r.right - r.left, 1, PATCOPY);
+    NtGdiPatBlt(hDC, r.left, r.bottom - 1, r.right - r.left, 1, PATCOPY);
+
+    NtGdiSelectBrush(hDC, oldbrush);
+    return TRUE;
+}
+
+
+INT WINAPI
 FillRect(HDC hDC, CONST RECT *lprc, HBRUSH hbr)
 {
     BOOL Ret;
Index: win32ss/user/ntuser/main.c
===================================================================
--- win32ss/user/ntuser/main.c	(revision 68654)
+++ win32ss/user/ntuser/main.c	(working copy)
@@ -461,6 +461,7 @@
     PTEB pTeb;
     LARGE_INTEGER LargeTickCount;
     PRTL_USER_PROCESS_PARAMETERS ProcessParams;
+    PMENUSTATE pms;
 
     Process = Thread->ThreadsProcess;
 
@@ -478,6 +479,15 @@
         return Status;
     }
 
+    /* Allocate Menu State structure */
+    pms = ExAllocatePoolWithTag(NonPagedPool, sizeof(*pms), USERTAG_MENUSTATE);
+    if ( pms == NULL)
+    {
+        ERR_CH(UserThread, "Failed to allocate thread menu state\n");
+        return STATUS_NO_MEMORY;
+    }
+    ptiCurrent->pMenuState = pms;
+
     /* Initialize the THREADINFO */
     ptiCurrent->pEThread = Thread;
     ptiCurrent->ppi = PsGetProcessWin32Process(Process);
Index: win32ss/user/ntuser/menu.c
===================================================================
--- win32ss/user/ntuser/menu.c	(revision 68654)
+++ win32ss/user/ntuser/menu.c	(working copy)
@@ -11,13 +11,26 @@
 
 /* INTERNAL ******************************************************************/
 
+HFONT ghMenuFont = NULL;
+HFONT ghMenuFontBold = NULL;
+static SIZE MenuCharSize;
+
 BOOL FASTCALL IntSetMenuItemInfo(PMENU, PITEM, PROSMENUITEMINFO, PUNICODE_STRING);
 
+/* internal popup menu window messages */
+
+#define MM_SETMENUHANDLE        (WM_USER + 0)
+#define MM_GETMENUHANDLE        (WM_USER + 1)
+
 /* maximum allowed depth of any branch in the menu tree.
  * This value is slightly larger than in windows (25) to
  * stay on the safe side. */
 #define MAXMENUDEPTH 30
 
+#define MENU_TYPE_MASK (MF_STRING | MF_BITMAP | MF_OWNERDRAW | MF_SEPARATOR)
+
+//#define MENU_ITEM_TYPE(flags) ((flags) & MENU_TYPE_MASK)
+
 #define MNS_STYLE_MASK (MNS_NOCHECK|MNS_MODELESS|MNS_DRAGDROP|MNS_AUTODISMISS|MNS_NOTIFYBYPOS|MNS_CHECKORBMP)
 
 #define MENUITEMINFO_TYPE_MASK \
@@ -33,10 +46,38 @@
 
 #define MII_STATE_MASK (MFS_GRAYED|MFS_CHECKED|MFS_HILITE|MFS_DEFAULT)
 
+#define IS_SYSTEM_MENU(MenuInfo)  \
+	(0 == ((MenuInfo)->fFlags & MNF_POPUP) && 0 != ((MenuInfo)->fFlags & MNF_SYSMENU))
+
+#define IS_SYSTEM_POPUP(MenuInfo) \
+	(0 != ((MenuInfo)->fFlags & MNF_POPUP) && 0 != ((MenuInfo)->fFlags & MNF_SYSMENU))
+
+#define IS_BITMAP_ITEM(flags) (MF_BITMAP == MENU_ITEM_TYPE(flags))
+
+#define IS_MAGIC_BITMAP(id) ((id) && ((INT_PTR)(id) < 12) && ((INT_PTR)(id) >= -1))
+#define IS_STRING_ITEM(flags) (MF_STRING == MENU_ITEM_TYPE(flags))
+
 /* Maximum number of menu items a menu can contain */
 #define MAX_MENU_ITEMS (0x4000)
 #define MAX_GOINTOSUBMENU (0x10)
 
+/*  top and bottom margins for popup menus */
+#define MENU_TOP_MARGIN 2 //3
+#define MENU_BOTTOM_MARGIN 2
+
+#define MENU_ITEM_HBMP_SPACE (5)
+#define MENU_BAR_ITEMS_SPACE (12)
+#define SEPARATOR_HEIGHT (5)
+#define MENU_TAB_SPACE (8)
+
+/* Internal MenuTrackMenu() flags */
+#define TPM_INTERNAL            0xF0000000
+#define TPM_BUTTONDOWN          0x40000000              /* menu was clicked before tracking */
+#define TPM_POPUPMENU           0x20000000              /* menu is a popup menu */
+
+#define ITEM_PREV               -1
+#define ITEM_NEXT                1
+
 #define UpdateMenuItemState(state, change) \
 {\
   if((change) & MF_GRAYED) { \
@@ -133,6 +174,26 @@
   } \
 }
 
+PWND FASTCALL
+IntGetMSWND(PMENUSTATE pms)
+{
+   PWND pWnd = NULL;
+   if (pms)
+   {
+       if (pms->pGlobalPopupMenu->fIsTrackPopup)
+       {
+          pWnd = pms->pGlobalPopupMenu->spwndPopupMenu;
+       }
+       else if (pms->pGlobalPopupMenu->spwndNextPopup)
+       {
+          pWnd = pms->pGlobalPopupMenu->spwndNextPopup;
+       }
+       else
+          pWnd = pms->pGlobalPopupMenu->spwndActivePopup;
+   }
+   return pWnd;
+}
+
 PMENU FASTCALL
 IntGetMenuObject(HMENU hMenu)
 {
@@ -269,6 +330,47 @@
    return FALSE;
 }
 
+BOOL
+MenuInit(VOID)
+{
+  NONCLIENTMETRICSW ncm;
+
+  /* get the menu font */
+  if (!ghMenuFont || !ghMenuFontBold)
+  {
+    ncm.cbSize = sizeof(ncm);
+    if(!UserSystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(ncm), &ncm, 0))
+    {
+      ERR("MenuInit(): SystemParametersInfo(SPI_GETNONCLIENTMETRICS) failed!\n");
+      return FALSE;
+    }
+
+    ghMenuFont = GreCreateFontIndirectW(&ncm.lfMenuFont);
+    if (ghMenuFont == NULL)
+    {
+      ERR("MenuInit(): CreateFontIndirectW(hMenuFont) failed!\n");
+      return FALSE;
+    }
+    ncm.lfMenuFont.lfWeight = max(ncm.lfMenuFont.lfWeight + 300, 1000);
+    ghMenuFontBold = GreCreateFontIndirectW(&ncm.lfMenuFont);
+    if (ghMenuFontBold == NULL)
+    {
+      ERR("MenuInit(): CreateFontIndirectW(hMenuFontBold) failed!\n");
+      GreDeleteObject(ghMenuFont);
+      ghMenuFont = NULL;
+      return FALSE;
+    }
+    
+    GreSetObjectOwner(ghMenuFont, GDI_OBJ_HMGR_PUBLIC);
+    GreSetObjectOwner(ghMenuFontBold, GDI_OBJ_HMGR_PUBLIC);
+
+    co_IntSetupOBM();
+  }
+
+  return TRUE;
+}
+
+
 /**********************************************************************
  *		MENU_depth
  *
@@ -355,6 +457,45 @@
     return fallback;
 }
 
+/***********************************************************************
+ *           MenuFindSubMenu
+ *
+ * Find a Sub menu. Return the position of the submenu, and modifies
+ * *hmenu in case it is found in another sub-menu.
+ * If the submenu cannot be found, NO_SELECTED_ITEM is returned.
+ */
+static UINT FASTCALL MENU_FindSubMenu(PMENU *menu, PMENU SubTarget )
+{
+    UINT i;
+    PITEM item;
+
+    item = ((PMENU)*menu)->rgItems;
+    for (i = 0; i < ((PMENU)*menu)->cItems; i++, item++)
+    {
+        if (!item->spSubMenu)
+           continue;
+        else
+        {
+           if (item->spSubMenu == SubTarget)
+           {
+              return i;
+           }
+           else 
+           {
+              PMENU pSubMenu = item->spSubMenu;
+              UINT pos = MENU_FindSubMenu( &pSubMenu, SubTarget );
+              if (pos != NO_SELECTED_ITEM)
+              {
+                  *menu = pSubMenu;
+                  return pos;
+              }
+           }
+        }
+    }
+    return NO_SELECTED_ITEM;
+}
+
+
 BOOL FASTCALL
 IntRemoveMenuItem( PMENU pMenu, UINT nPos, UINT wFlags, BOOL bRecurse )
 {
@@ -1019,29 +1160,8 @@
    return res;
 }
 
-BOOL FASTCALL
-IntHiliteMenuItem(PWND WindowObject,
-                  PMENU MenuObject,
-                  UINT uItemHilite,
-                  UINT uHilite)
-{
-   PITEM MenuItem;
 
-   if (!(MenuItem = MENU_FindItem( &MenuObject, &uItemHilite, uHilite ))) return FALSE;
 
-   if (uHilite & MF_HILITE)
-   {
-      MenuItem->fState |= MF_HILITE;
-   }
-   else
-   {
-      MenuItem->fState &= ~MF_HILITE;
-   }
-   /* FIXME: Update the window's menu */
-
-   return TRUE; // Always returns true!!!!
-}
-
 BOOL FASTCALL
 UserSetMenuDefaultItem(PMENU MenuObject, UINT uItem, UINT fByPos)
 {
